/**
 * web_servicecontroller_webservices.h: Static functions, that can be called
 * in order to use last.fm webservice.
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id:  2009-07-17 10:03:46  mf $
 */

#ifndef __WEB_SERVICECONNECTOR_WEBSERVICES_H
#define __WEB_SERVICECONNECTOR_WEBSERVICES_H

#include <string>
#include <inttypes.h>

class cWebServiceConnectorWebservices_auth
{
public:
	static uint8_t getMobileSession(const std::string username, const std::string passphrase_md5,
				    std::string & websvcs_session, std::string & authtoken);
};

class cWebServiceConnectorWebservices_track
{
public:
	/**
	 * track (Required) : A track name (utf8 encoded)
	 * artist (Required) : An artist name (utf8 encoded)
	 * api_key (Required) : A Last.fm API key.
	 * api_sig (Required) : A Last.fm method signature. See authentication for more information.
	 * sk (Required) : A session key generated by authenticating a user via the authentication protocol.
	 */
	static uint8_t love(const std::string track, const std::string artist,
			const std::string api_key, const std::string api_sig, const std::string sk);
	static uint8_t ban(const std::string track, const std::string artist,
		       const std::string api_key, const std::string api_sig, const std::string sk);
	static uint8_t updateNowPlaying(const std::string track, const std::string artist,
		       const std::string sk);
	static uint8_t scrobble(const std::string track, const std::string timestamp, const std::string artist,
		       const std::string sk);

};


class cWebServiceConnectorWebservices_artist
{
public:
	static uint8_t getInfo(const std::string artist, const std::string mbid, const std::string lang, const std::string api_key, std::string & content);
};

class cWebServiceConnectorWebservices_user
{
public:
	static uint8_t getRecentTracks(std::string & content, const std::string user, const std::string api_key, const uint16_t limit=-1);
	static uint8_t getLovedTracks(std::string & content, const std::string user, const std::string api_key);
	static uint8_t getRecentStations(std::string &content, const std::string user, const std::string api_key, const uint16_t limit=1);
};

class cWebServiceConnectorWebservices
{
public:
	static cWebServiceConnectorWebservices_auth auth;
	static cWebServiceConnectorWebservices_track track;
	static cWebServiceConnectorWebservices_artist artist;
	static cWebServiceConnectorWebservices_user user;
};


#endif // __WEB_SERVICECONNECTOR_WEBSERVICES_H
